/*****************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 7.3728 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

#include <si47xx.c>

eeprom unsigned int null;
eeprom unsigned int load_FREQ;
eeprom unsigned char preset = 0;

unsigned char ind = 0, temp;


#define on	0
#define off	1

#define led1	PORTC.4
#define led2	PORTB.4
#define led3	PORTB.3
#define led4	PORTB.5
#define led5	PORTD.4
#define led6	PORTB.2

#define snd	PORTB.0

#define but 	!PINB.1

#define zero 	PINC.3
#define play 	!PINC.5

#define disk	PORTD.5


// I2C Bus functions
#asm
   .equ __i2c_port=0x12 ;PORTD
   .equ __sda_bit=6
   .equ __scl_bit=7
#endasm
#include <i2c.h>

unsigned int a,b,c,d;


//******************************************************************************

unsigned char byte0, byte1, byte2, byte3, byte4;

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
led5=on;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
led5=off;
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

// 
void sound (unsigned int time)
        {
        unsigned int i;
        
        for (i=0; i<time; i++)
                {
                snd = 1;
                delay_us(500);
                snd = 0;
                delay_us(500);
                }
        }

unsigned char timer_int;	 

// Timer 1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
        {
        TCNT1H=0xE3;
        TCNT1L=0xE0;
        
	timer_int++;
              
        if (timer_int == 1) sound (10);
//         if (timer_int == 2)
//                 {
//                 sound (10);
//                 delay_ms(40);
//                 sound (10);
//                 }
//         if (timer_int == 3)
//                 {
//                 sound (10);
//                 delay_ms(40);
//                 sound (10);
//                 delay_ms(40);
//                 sound (10);
//                 timer_int = 0;
//                 }
        } 

unsigned char timer2cnt = 0;

// 
// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
        {
        TCNT2=0x38;
        if (++timer2cnt == 54)
                {
                timer2cnt = 0;
                if (play) led1 = !led1; else led1 = on;
                ++temp;
                }
	}


void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=Out 
// State7=T State6=T State5=1 State4=1 State3=1 State2=1 State1=P State0=0 
PORTB=0x3E;
DDRB=0x3D;

// Port C initialization
// Func6=In Func5=In Func4=Out Func3=In Func2=Out Func1=Out Func0=In 
// State6=T State5=P State4=1 State3=P State2=0 State1=0 State0=T 
PORTC=0x38;
DDRC=0x16;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=0 State4=1 State3=T State2=T State1=0 State0=P 
PORTD=0x11;
DDRD=0x32;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// TCCR0=0x00;
// TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 10,800 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// TCCR1A=0x00;
// TCCR1B=0x00;
TCNT1H=0xE3;
TCNT1L=0xE0;
// ICR1H=0x00;
// ICR1L=0x00;
// OCR1AH=0x00;
// OCR1AL=0x00;
// OCR1BH=0x00;
// OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 10,800 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
// ASSR=0x00;
TCCR2=0x07;
TCNT2=0x38;
// OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x44;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 115200
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x03;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// I2C Bus initialization
i2c_init();

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Global enable interrupts
#asm("sei")



delay_ms(1000);

null = 1;	//     

//sound (50);
//  )
led1=on;
delay_ms(150);
led1=off;
led2=on;
delay_ms(150);
led2=off;
led3=on;
delay_ms(150);
led3=off;
led4=on;
delay_ms(150);
led4=off;
led5=on;
delay_ms(150);
led5=off;
led6=on;
delay_ms(150);
led6=off;
led5=on;
delay_ms(150);
led5=off;
led4=on;
delay_ms(150);
led4=off;
led3=on;
delay_ms(150);
led3=off;
led2=on;
delay_ms(150);
led2=off;
led1=on;
delay_ms(150);
led1=off;

reinit = 1;
while (reinit) si_init();	//,   -  

if (preset > 20) preset = 0; 	//     

if (load_FREQ == 0xFFFF) FREQ = 8800 + (unsigned int)(preset)*100;
	else FREQ = load_FREQ;
launch_TX_TUNE_FREQ (FREQ);
waiting ();
launch_TX_ASQ_STATUS (INTACK);
waiting ();
#ifdef DEBUG
printf ("OK, FREQ=%d, OVERMOD=%d, INLEVEL=%d\r\n", read_FREQ, OVERMOD, INLEVEL);
#endif	

while (1)
      	{
	#asm("wdr");
	if (but)                                               	//  
                {
                delay_ms(10);
                if (but) 
                        {
                        TCCR1B=0x05;                            //  1
                        while (but) #asm("wdr");                //,   
                        switch (timer_int)			//     
                                {
                                case 0: {                       //   ""
                                	if (++preset > 20 || load_FREQ != 0xFFFF) preset = 0;
                                	FREQ = 8800 + (unsigned int)(preset)*100;
                                	launch_TX_TUNE_FREQ (FREQ);
					putchar (resp[0]);
					waiting ();
					INTACK = 0;
					launch_TX_ASQ_STATUS (INTACK);
					waiting ();
					printf ("OK, FREQ=%d.%d, OVERMOD=%d, INLEVEL=%d\r\n", read_FREQ/100, read_FREQ%100, OVERMOD, INLEVEL);
					load_FREQ = 0xFFFF;
                                	sound(5);
                                	}; break;
                                case 1: {			// / 
                                	disk = !disk;
                                	if (disk) printf ("FLASH Disk on-line\r\n"); else printf ("FLASH Disk off-line\r\n");
                                	};
                                }
     			TCCR1B=0x00;                            //  1
        		TCNT1H=0xE3;
        		TCNT1L=0xE0;
        		timer_int = 0;
                        }
                }
	
	if (rx_counter)			// -   
		{	
		byte0 = getchar();
		
		if (byte0 == 0xAA)	//  ,  4    
			{
			byte1 = getchar();
			byte2 = getchar();
			
			a = (byte1&0xF0)/16;
			b = byte1&0x0F;
			c = (byte2&0xF0)/16;
			d = byte2&0x0F;
			
			FREQ = (a*1000+b*100+c*10+d)*10;
			launch_TX_TUNE_FREQ (FREQ);
			putchar (resp[0]);
                        waiting ();
                        INTACK = 0;
			launch_TX_ASQ_STATUS (INTACK);
        		waiting ();
			printf ("OK, FREQ=%d.%d, OVERMOD=%d, INLEVEL=%d\r\n", read_FREQ/100, read_FREQ%100, OVERMOD, INLEVEL);
			load_FREQ = FREQ;
			}
		
		if (byte0 == 0xBB)	//  
			{
			byte1=getchar();
			byte2=getchar();
			launch_GET_PROPERTY (((unsigned int)(byte1)*256 + (unsigned int)(byte2)));
                        putchar(resp[2]);
                        putchar(resp[3]);
                        putchar (resp[0]);
                        waiting ();
                        }
   		if (byte0 == 0xCC)	//  
			{
			byte1=getchar();
			byte2=getchar();
			byte3=getchar();
			byte4=getchar();
			launch_SET_PROPERTY (((unsigned int)(byte1)*256 + (unsigned int)(byte2)), ((unsigned int)(byte3)*256 + (unsigned int)(byte4)));
                        putchar (resp[0]);
                        waiting ();
                        }
                if (byte0 == 0x55)	//
			{
			reinit = 1;
			while (reinit) si_init();
                        }
                }
   	// -   5 
   	if (load_FREQ == 0xFFFF) ind = preset; else ind = temp;	
	if ((ind&1)) led2 = on; else led2 = off;
   	if (((ind/2)&1)) led3 = on; else led3 = off;
   	if (((ind/4)&1)) led4 = on; else led4 = off;
   	if (((ind/8)&1)) led5 = on; else led5 = off;
   	if (((ind/16)&1)) led6 = on; else led6 = off;
   	};
}
