#include <i2c.h>
#include <delay.h>
#include <stdio.h>

// , ,     .   .     

#define FULL_DATA       // ,   ,       .
//#define SI4712	  // .    
#define DEBUG		//  
#define RDS_ENABLE	//.    RDS (      )

#define System_CLK      7372800                 // , Hz
#define REF_CLK         32768                   // 
#define PRESCALE        System_CLK/REF_CLK      // 

#define sen 	PORTC.1		//   i2c    , ..     
#define rst 	PORTC.2         // , ..      
unsigned char reinit = 0;	// ,     ,  = 1    

#define si_addr	0x22    //if sen = 0,   
//#define si_addr 0xC6    //if sen = 1,   

//      Command                 Code       Description
#define	POWER_UP	        0x01	// Power up device and mode selection. Modes include FM transmit and analog/digital audio interface configuration.							
#define	GET_REV	                0x10	// Returns revision information on the device.							
#define	POWER_DOWN	        0x11	// Power down device.							
#define	SET_PROPERTY	        0x12	// Sets the value of a property.							
#define	GET_PROPERTY	        0x13	// Retrieves a propertys value.							
#define	GET_INT_STATUS	        0x14	// Read interrupt status bits.							
#define	PATCH_ARGS	        0x15	// Reserved command used for patch file downloads.							
#define	PATCH_DATA	        0x16	// Reserved command used for patch file downloads.							
#define	TX_TUNE_FREQ	        0x30    // Tunes to given transmit frequency.																								
#define	TX_TUNE_POWER	        0x31	// Sets the output power level and tunes the antenna capacitor																								
#define	TX_TUNE_MEASURE	        0x32	// Si4712/13 Only. Measure the received noise level at the specified frequency.																								
#define	TX_TUNE_STATUS	        0x33	// Queries the status of a previously sent TX Tune Freq, TX Tune Power, or TX Tune Measure command.																								
#define	TX_ASQ_STATUS	        0x34	// Queries the TX status and input audio signal metrics.																								
#define	TX_RDS_BUFF	        0x35	// Si4711/13 Only. Queries the status of the RDS Group Buffer and loads new data into buffer.																								
#define	TX_RDS_PS	        0x36	// Si4711/13 Only. Set up default PS strings.																								
#define	GPIO_CTL	        0x80	// Configures GPO3 as output or Hi-Z.																								
#define	GPIO_SET	        0x81	// Sets GPIO3 output level (low or high).																								

#ifdef FULL_DATA
//  
//  ,    ,       .
//  -   ,   

//***//POWER_UP
//-->>
unsigned char CTSIEN, GPO2OEN, PATCH, FUNC, OPMODE;
//<<--
unsigned char PN, FWMAJOR, FWMINOR, CHIPREV, LIBRARYID;

//***//GET_REV
//-->>
//none
//<<--
unsigned char PATCHH, PATCHL, CMPMAJOR, CMPMINOR;

//***//TX_TUNE_FREQ
//-->>
unsigned int FREQ;
//<<--
//none

//***//TX_TUNE_POWER
//-->>
unsigned char RFdBu, ANTCAP;
//<<--
//none

//***//TX_TUNE_STATUS
//-->>
unsigned char INTACK;
//<<--
unsigned int read_FREQ;
unsigned char read_RFdBu, read_ANTCAP, RNL;

//***//TX_ASQ_STATUS
//-->>
//unsigned char INTACK;
//<<--
unsigned char OVERMOD, IALH, IALL, INLEVEL;

#ifdef RDS_ENABLE
//***//TX_RDS_BUFF
//-->>
unsigned char FIFO, LDBUFF, MTBUFF;
unsigned int RDSB, RDSC, RDSD;
//<<--
unsigned char RDSPSXMIT, CBUFXMIT, FIFOXMIT, CBUFWRAP, FIFOMT, CBAVAIL, CBUSED, FIFOAVAIL, FIFOUSED;

//***//TX_RDS_PS
//-->>
unsigned char PSID, char0, char1, char2, char3;
//<<--
//none
#endif

//***//GPIO_CTL
//-->>
unsigned char GPO3OEN;
//<<--
//none

//***//GPIO_SET	
//-->>
unsigned char GPO3OLEVEL;
//<<--
//none
#endif

																											
//      Property                        Code       Description, default value																											
#define	GPO_IEN	                        0x0001	// Enables interrupt sources. 0x0000																								
#define	DIGITAL_INPUT_FORMAT	        0x0101	// Configures the digital input format. 0x0000																								
#define	DIGITAL_INPUT_SAMPLE_RATE       0x0103	// Configures the digital input sample rate in 10 Hz steps. Default is 0. 0x0000																								
#define	REFCLK_FREQ	                0x0201	// Sets frequency of the reference clock in Hz. The range is 31130 to 34406 Hz, or 0 to disable the AFC. Default is 32768 Hz. 0x8000																								
#define	REFCLK_PRESCALE	                0x0202	// Sets the prescaler value for the reference clock. 0x0001																								
#define	TX_COMPONENT_ENABLE	        0x2100	// Enable transmit multiplex signal components. Default has pilot and L-R enabled. 0x0003																								
#define	TX_AUDIO_DEVIATION	        0x2101	// Configures audio frequency deviation level. Units are in 10 Hz increments. Default is 6285 (68.25 kHz). 0x1AA9																								
#define	TX_PILOT_DEVIATION	        0x2102	// Configures pilot tone frequency deviation level. Units are in 10 Hz increments. Default is 675 (6.75 kHz) 0x02A3																								
#define	TX_RDS_DEVIATION	        0x2103	// Si4711/13 Only. Configures the RDS/RBDS frequency deviation level. Units are in 10 Hz increments. Default is 2 kHz. 0x00C8																								
#define	TX_LINE_INPUT_LEVEL	        0x2104	// Configures maximum analog line input level to the LIN/RIN pins to reach the maximum deviation level programmed into the audio deviation property TX Audio Deviation. Default is 636 mVPK. 0x327C																								
#define	TX_LINE_INPUT_MUTE	        0x2105	// Sets line input mute. L and R inputs may be independently muted. Default is not muted. 0x0000																								
#define	TX_PREEMPHASIS	                0x2106	// Configures pre-emphasis time constant. Default is 0 (75 ?S). 0x0000																								
#define	TX_PILOT_FREQUENCY	        0x2107	// Configures the frequency of the stereo pilot. Default is 19000 Hz. 0x4A38																								
#define	TX_ACOMP_ENABLE	                0x2200	// Enables audio dynamic range control. Default is 0 (disabled). 0x0002																								
#define	TX_ACOMP_THRESHOLD	        0x2201	// Sets the threshold level for audio dynamic range control. Default is 40 dB. 0xFFD8																								
#define	TX_ACOMP_ATTACK_TIME	        0x2202	// Sets the attack time for audio dynamic range control. Default is 0 (0.5 ms). 0x0000																								
#define	TX_ACOMP_RELEASE_TIME	        0x2203	// Sets the release time for audio dynamic range control. Default is 4 (1000 ms). 0x0004																								
#define	TX_ACOMP_GAIN	                0x2204	// Sets the gain for audio dynamic range control. Default is 15 dB. 0x000F																								
#define	TX_LIMITER_RELEASE_TIME	        0x2205	// Sets the limiter release time. Default is 102 (5.01 ms) 0x0066																								
#define	TX_ASQ_INTERRUPT_SOURCE	        0x2300	// Configures measurements related to signal quality metrics. Default is none selected. 0x0000																								
#define	TX_ASQ_LEVEL_LOW	        0x2301	// Configures low audio input level detection threshold. This threshold can be used to detect silence on the incoming audio. 0x0000																								
#define	TX_ASQ_DURATION_LOW	        0x2302	// Configures the duration which the input audio level must be below the low threshold in order to detect a low audio condition. 0x0000																								
#define	TX_ASQ_LEVEL_HIGH	        0x2303	// Configures high audio input level detection threshold. This threshold can be used to detect activity on the incoming audio. 0x0000																								
#define	TX_ASQ_DURATION_HIGH	        0x2304	// Configures the duration which the input audio level must be above the high threshold in order to detect a high audio condition. 0x0000																								
#define	TX_RDS_INTERRUPT_SOURCE	        0x2C00	// Si4711/13 Only. Configure RDS interrupt sources. Default is none selected. 0x0000																								
#define	TX_RDS_PI	                0x2C01	// Si4711/13 Only. Sets transmit RDS program identifier. 0x40A7																								
#define	TX_RDS_PS_MIX	                0x2C02	// Si4711/13 Only. Configures mix of RDS PS Group with RDS Group Buffer. 0x0003																								
#define	TX_RDS_PS_MISC	                0x2C03	// Si4711/13 Only. Miscellaneous bits to transmit along with RDS_PS Groups. 0x1008																								
#define	TX_RDS_PS_REPEAT_COUNT	        0x2C04	// Si4711/13 Only. Number of times to repeat transmission of a PS message before transmitting the next PS message. 0x0003																								
#define	TX_RDS_PS_MESSAGE_COUNT	        0x2C05	// Si4711/13 Only. Number of PS messages in use. 0x0001																								
#define	TX_RDS_PS_AF	                0x2C06	// Si4711/13 Only. RDS Program Service Alternate Frequency. This provides the ability to inform the receiver of a single alternate frequency using AF Method A coding and is transmitted along with the RDS_PS Groups. 0xE0E0																								
#define	TX_RDS_FIFO_SIZE	        0x2C07	// Si4711/13 Only. Number of blocks reserved for the FIFO. Note that the value written must be one larger than the desired FIFO size. 0x0000																								

//   ,       load_property (property_ID)   .
//  -   
#ifdef FULL_DATA	
unsigned int RDSREP, ASQREP, STCREP, ERRIEN, RDSIEN, ASQIEN, STCIEN;
unsigned int IFALL, IMODE, IMONO, ISIZE;
unsigned int DISR;
unsigned int REFCLKF;
unsigned int REFCLKP;
unsigned int RDS, LMR, PILOT;
unsigned int TXADEV;
unsigned int TXPDEV;
unsigned int TXRDEV;
unsigned int LIATTEN, LILEVEL;
unsigned int LIMUTE, RIMUTE;
unsigned int FMPE;
unsigned int PILOT_FREQ;
unsigned int LIMITEN, ACEN;
unsigned int THRESHOLD;
unsigned int ATTACK;
unsigned int RELEASE;
unsigned int GAIN;
unsigned int LIMITERTC;
unsigned int OVERMODIEN, IALHIEN, IALLIEN; 
unsigned int IALLTH;
unsigned int IALLDUR;
unsigned int IALHTH;
unsigned int IALHDUR;
#ifdef RDS_ENABLE
unsigned int RDSCBUFXMIT, RDSFIFOXMIT, RDSCBUFWRAP, RDSFIFOMT;
unsigned int RDSPI;
unsigned int RDSPSMIX;
unsigned int RDSD3, RDSD2, RDSD1, RDSD0, FORCEB, RDSTP, RDSPTY, RDSTA, RDSMS;
unsigned int RDSPSRC;
unsigned int RDSPSMC;
unsigned int RDSAF;
unsigned int RDSFIFOSZ;
#endif
#endif

unsigned char resp[9];	//  -     
#define CTS     resp[0]&0b10000000 >> 7	//  . .      
#define ERR     resp[0]&0b01000000 >> 6 
#define RDSINT  resp[0]&0b00000100 >> 2 
#define ASQINT  resp[0]&0b00000010 >> 1 
#define STCINT  resp[0]&0b00000001

#define read_delay()	delay_ms(50)	//        ,  

unsigned int counter;	//   
void waiting (void)	//   :         
	{
	counter = 0;
	while ((!CTS || ERR) && counter<250) 
        	{
        	i2c_start();
		i2c_write(si_addr+1);
		resp[0] = i2c_read(0);
		i2c_stop();
		#asm("wdr");
		delay_ms(2);
		counter++;
		}
	#ifdef DEBUG
	if ((counter >= 250 || ERR)) {printf ("ERROR, CTS=%d, ERR=%d, CNT=%d\r\n", CTS, ERR, counter); reinit = 1;} 
		else printf ("OK\r\n");
	#endif 
	}

//
void launch_POWER_UP (unsigned char CTSIEN, unsigned char GPO2OEN, unsigned char PATCH, unsigned char FUNC, unsigned char OPMODE)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(POWER_UP);
        i2c_write(CTSIEN*128 + GPO2OEN*64 + PATCH*32 + FUNC);
        i2c_write(OPMODE);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	if (FUNC == 2) resp[0] = i2c_read(0);
	if (FUNC == 15)
	        {
	        resp[0] = i2c_read(1);
	        resp[1] = i2c_read(1);
	        resp[2] = i2c_read(1);
	        resp[3] = i2c_read(1);
	        resp[4] = i2c_read(1);
	        resp[5] = i2c_read(1);
	        resp[6] = i2c_read(1);
	        resp[7] = i2c_read(1);
	        resp[8] = i2c_read(0);
	        }
	i2c_stop();
	
	#ifdef FULL_DATA
	PN = resp[1];
	FWMAJOR = resp[2];
	FWMINOR = resp[3];
	CHIPREV = resp[6];
	LIBRARYID = resp[7];
	#endif
	}

void launch_GET_REV (void)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(GET_REV);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(1);
	resp[1] = i2c_read(1);
	resp[2] = i2c_read(1);
	resp[3] = i2c_read(1);
	resp[4] = i2c_read(1);
	resp[5] = i2c_read(1);
	resp[6] = i2c_read(1);
	resp[7] = i2c_read(1);
	resp[8] = i2c_read(0);
	i2c_stop();
	
	#ifdef FULL_DATA
	PN = resp[1];
	FWMAJOR = resp[2];
	FWMINOR = resp[3];
	PATCHH = resp[4];
	PATCHL = resp[5];
	CMPMAJOR = resp[6];
	CMPMINOR = resp[7];
	CHIPREV = resp[8];
	#endif
	}
	
void launch_POWER_DOWN (void)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(POWER_DOWN);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	}
	
void launch_SET_PROPERTY (unsigned int PROP_ID, unsigned int PROP_VAL)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(SET_PROPERTY);
        i2c_write(0);
        i2c_write((unsigned char)((PROP_ID&0xff00)>>8));
        i2c_write((unsigned char)(PROP_ID&0x00ff));
        i2c_write((unsigned char)((PROP_VAL&0xff00)>>8));
        i2c_write((unsigned char)(PROP_VAL&0x00ff));
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	}
	
unsigned int launch_GET_PROPERTY (unsigned int PROP_ID)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(GET_PROPERTY);
        i2c_write(0);
        i2c_write((unsigned char)((PROP_ID&0xff00)>>8));
        i2c_write((unsigned char)(PROP_ID&0x00ff));
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(1);
        resp[1] = i2c_read(1);
        resp[2] = i2c_read(1);
        resp[3] = i2c_read(0);
        i2c_stop();
	
	return ((unsigned int)(resp[2])*256 + (unsigned int)(resp[3]));
	}
	
void launch_GET_INT_STATUS (void)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(GET_INT_STATUS);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	}	

void launch_TX_TUNE_FREQ (unsigned int FREQ)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_TUNE_FREQ);
        i2c_write(0);
        i2c_write((unsigned char)((FREQ&0xff00)>>8));
        i2c_write((unsigned char)(FREQ&0x00ff));
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	}	

void launch_TX_TUNE_POWER (unsigned char RFdBu, unsigned char ANTCAP)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_TUNE_POWER);
        i2c_write(0);
        i2c_write(0);
        i2c_write(RFdBu);
        i2c_write(ANTCAP);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	}	

#ifdef SI4712	//Si4712/13 Only	
void launch_TX_TUNE_MEASURE (unsigned int FREQ, unsigned char ANTCAP)
        {
        unsigned char FREQH, FREQL;
        
        FREQH = (unsigned char)((FREQ&0xff00)>>8);
        FREQL = (unsigned char)(FREQ&0x00ff);
        
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_TUNE_MEASURE);
        i2c_write(0);
        i2c_write(FREQH);
        i2c_write(FREQL);
        i2c_write(ANTCAP);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
        i2c_stop();
	   }
#endif	

void launch_TX_TUNE_STATUS (unsigned char INTACK)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_TUNE_STATUS);
        i2c_write(INTACK);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(1);
	resp[1] = i2c_read(1);
	resp[2] = i2c_read(1);
	resp[3] = i2c_read(1);
	resp[4] = i2c_read(1);
	resp[5] = i2c_read(1);
	resp[6] = i2c_read(1);
	resp[7] = i2c_read(0);
	i2c_stop();
	
	#ifdef FULL_DATA
	read_FREQ = ((unsigned int)(resp[2]))*256 + ((unsigned int)(resp[3]));
	read_RFdBu = resp[5];
	read_ANTCAP = resp[6];
	RNL = resp[7];
	#endif
	}	

void launch_TX_ASQ_STATUS (unsigned char INTACK)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_ASQ_STATUS);
        i2c_write(INTACK);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(1);
	resp[1] = i2c_read(1);
	resp[2] = i2c_read(1);
	resp[3] = i2c_read(1);
	resp[4] = i2c_read(0);
	i2c_stop();
	
	#ifdef FULL_DATA
	read_FREQ = ((unsigned int)(resp[2]))*256 + ((unsigned int)(resp[3]));
	OVERMOD = (resp[1]&0b00000100) >> 2;
	IALH = (resp[1]&0b00000010) >> 1;
	IALL = (resp[1]&0b00000001);
	INLEVEL = resp[4];
	#endif
	}	
#ifdef RDS_ENABLE 
void launch_TX_RDS_BUFF (unsigned char FIFO, unsigned char LDBUFF, unsigned char MTBUFF, unsigned char INTACK, unsigned int RDSB, unsigned int RDSC, unsigned int RDSD)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_RDS_BUFF);
        i2c_write(FIFO*128 + LDBUFF*4 + MTBUFF*2 + INTACK);
        i2c_write((unsigned char)((RDSB&0xff00)>>8));
        i2c_write((unsigned char)(RDSB&0x00ff));
        i2c_write((unsigned char)((RDSC&0xff00)>>8));
        i2c_write((unsigned char)(RDSC&0x00ff));
        i2c_write((unsigned char)((RDSD&0xff00)>>8));
        i2c_write((unsigned char)(RDSD&0x00ff));
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(1);
	resp[1] = i2c_read(1);
	resp[2] = i2c_read(1);
	resp[3] = i2c_read(1);
	resp[4] = i2c_read(1);
	resp[5] = i2c_read(0);
	i2c_stop();
	
	#ifdef FULL_DATA
	RDSPSXMIT = (resp[1]&0b00010000) >> 4;
	CBUFXMIT = (resp[1]&0b00001000) >> 3;
	FIFOXMIT = (resp[1]&0b00000100) >> 2;
	CBUFWRAP = (resp[1]&0b00000010) >> 1;
	FIFOMT = (resp[1]&0b00000001);
	CBAVAIL = resp[2];
	CBUSED = resp[3];
	FIFOAVAIL = resp[4];
	FIFOUSED = resp[5];
	#endif
	}	

void launch_TX_RDS_PS (unsigned char PSID, unsigned char char0, unsigned char char1, unsigned char char2, unsigned char char3)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(TX_RDS_PS);
        i2c_write(PSID);
        i2c_write(char0);
        i2c_write(char1);
        i2c_write(char2);
        i2c_write(char3);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
	i2c_stop();
	}	                         
#endif

void launch_GPIO_CTL (unsigned char GPO3OEN)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(GPIO_CTL);
        i2c_write(GPO3OEN<<3);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
	i2c_stop();
	}	

void launch_GPIO_SET (unsigned char GPO3OLEVEL)
        {
        i2c_start();
        i2c_write(si_addr);
        i2c_write(GPIO_SET);
        i2c_write(GPO3OLEVEL<<3);
        i2c_stop();
        
        read_delay();
        
        i2c_start();
	i2c_write(si_addr+1);
	resp[0] = i2c_read(0);
	i2c_stop();
	}	
	
//**********************************************************************************************************************************************	
#ifdef FULL_DATA 
void load_property (unsigned int property_ID)
        {
        unsigned int value;
        switch (property_ID)
                {
                case GPO_IEN:                   {value = RDSREP*1024 + ASQREP*512 + STCREP*256 + (unsigned int)(CTSIEN)*128 + ERRIEN*64 + RDSIEN*4 + ASQIEN*2 + (unsigned int)(STCIEN);}; break;
                case DIGITAL_INPUT_FORMAT:      {value = IFALL*128 + IMODE*8 + IMONO*4 + ISIZE;}; break;
                case DIGITAL_INPUT_SAMPLE_RATE: {value = DISR;}; break;
                case REFCLK_FREQ:               {value = REFCLKF;}; break;
                case REFCLK_PRESCALE:           {value = REFCLKP;}; break;
                case TX_COMPONENT_ENABLE:       {value = RDS*4 + LMR*2 + PILOT;}; break;
                case TX_AUDIO_DEVIATION:        {value = TXADEV;}; break;
                case TX_PILOT_DEVIATION:        {value = TXPDEV;}; break;
                case TX_RDS_DEVIATION:          {value = TXRDEV;}; break;
                case TX_LINE_INPUT_LEVEL:       {value = LIATTEN*4096 + LILEVEL;}; break;
                case TX_LINE_INPUT_MUTE:        {value = LIMUTE*2 + RIMUTE;}; break;
                case TX_PREEMPHASIS:            {value = FMPE;}; break;
                case TX_PILOT_FREQUENCY:        {value = PILOT_FREQ;}; break;
                case TX_ACOMP_ENABLE:           {value = LIMITEN*2 + ACEN;}; break;
                case TX_ACOMP_THRESHOLD:        {value = THRESHOLD;}; break;
                case TX_ACOMP_ATTACK_TIME:      {value = ATTACK;}; break;
                case TX_ACOMP_RELEASE_TIME:     {value = RELEASE;}; break;
                case TX_ACOMP_GAIN:             {value = GAIN;}; break;
                case TX_LIMITER_RELEASE_TIME:   {value = LIMITERTC;}; break;
                case TX_ASQ_INTERRUPT_SOURCE:   {value = OVERMODIEN*4 + IALHIEN*2 + IALLIEN;}; break;
                case TX_ASQ_LEVEL_LOW:          {value = IALLTH;}; break;
                case TX_ASQ_DURATION_LOW:       {value = IALLDUR;}; break;
                case TX_ASQ_LEVEL_HIGH:         {value = IALHTH;}; break;
                case TX_ASQ_DURATION_HIGH:      {value = IALHDUR;}; break;
                #ifdef RDS_ENABLE
                case TX_RDS_INTERRUPT_SOURCE:   {value = (unsigned int)(RDSPSXMIT)*16 + RDSCBUFXMIT*8 + RDSFIFOXMIT*4 + RDSCBUFWRAP*2 + RDSFIFOMT;}; break;
                case TX_RDS_PI:                 {value = RDSPI;}; break;
                case TX_RDS_PS_MIX:             {value = RDSPSMIX;}; break;
                case TX_RDS_PS_MISC:            {value = RDSD3*32768 + RDSD2*16384 + RDSD1*8192 + RDSD0*4096 + FORCEB*2048 + RDSTP*1024 + RDSPTY*32 + RDSTA*16 + RDSMS*8;}; break;
                case TX_RDS_PS_REPEAT_COUNT:    {value = RDSPSRC;}; break;
                case TX_RDS_PS_MESSAGE_COUNT:   {value = RDSPSMC;}; break;
                case TX_RDS_PS_AF:              {value = RDSAF;}; break;
                case TX_RDS_FIFO_SIZE:          {value = RDSFIFOSZ;};
                #endif
                }
	launch_SET_PROPERTY (property_ID, value);
  	}
#else
void load_property(unsigned int property_ID, unsigned int property_value)
        {
        launch_SET_PROPERTY (property_ID, property_value);
  	}
#endif	
        
void si_init (void)	// ,      -  ,    
	{
        sen = 0;
        rst = 1;
        delay_ms(50);
        rst = 0;
        delay_ms(50);
        rst = 1;
        
        reinit = 0;

	//******Start Up       
        #ifdef DEBUG
        printf ("Launching POWER_UP CMD...\r\n");
        #endif
        CTSIEN=0; GPO2OEN=0; PATCH=0; FUNC=2; OPMODE=0b01010000;
	launch_POWER_UP (CTSIEN, GPO2OEN, PATCH, FUNC, OPMODE);
        waiting ();
        
	#ifdef DEBUG
        printf ("Launching GET_REV CMD...\r\n");
        #endif
	launch_GET_REV ();
	waiting ();
	#ifdef DEBUG
	printf ("OK, CHIPREV=%02X\r\n", CHIPREV);
	printf ("PN = %02X\r\n", PN);
	printf ("FWMAJOR = %02X\r\n", FWMAJOR);
	printf ("FWMINOR = %02X\r\n", FWMINOR);
	printf ("PATCHH = %02X\r\n", PATCHH);
	printf ("PATCHL = %02X\r\n", PATCHL);
	printf ("CMPMAJOR = %02X\r\n", CMPMAJOR);
	printf ("CMPMINOR = %02X\r\n", CMPMINOR);
	printf ("CHIPREV = %02X\r\n", CHIPREV);
	#endif
        
	#ifdef DEBUG
        printf ("****STARTUP & Config****\r\n");
        #endif
	
	#ifdef DEBUG
        printf ("Loading GPO_IEN Prop...\r\n");
        #endif
	RDSREP=0; ASQREP=0; STCREP=0; CTSIEN=0; ERRIEN=0; RDSIEN=0; ASQIEN=0; STCIEN=0;
	load_property (GPO_IEN);
	waiting ();
	
        #ifdef DEBUG
        printf ("Loading REFCLK_FREQ Prop...\r\n");
        #endif
	REFCLKF = REF_CLK; //32768 Hz
	load_property (REFCLK_FREQ);
	waiting ();
	#ifdef DEBUG
	printf ("REFCLKF = %d\r\n", REFCLKF);
	#endif
	
	#ifdef DEBUG
        printf ("Loading REFCLK_PRESCALE Prop...\r\n");
        #endif
	REFCLKP = PRESCALE; //225
	load_property (REFCLK_PRESCALE);
	waiting ();
	#ifdef DEBUG
	printf ("Prescale = %d\r\n", REFCLKP);
	#endif
	
	#ifdef DEBUG
        printf ("Loading TX_LINE_INPUT_LEVEL Prop...\r\n");
        #endif
	LIATTEN = 0b11;		//60kOhm
	LILEVEL = 636;		//636mVpk
	load_property (TX_LINE_INPUT_LEVEL);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_LINE_INPUT_MUTE Prop...\r\n");
        #endif
	LIMUTE = RIMUTE = 1;	//mute
	load_property (TX_LINE_INPUT_MUTE);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_PREEMPHASIS Prop...\r\n");
        #endif
	FMPE = 1;	//50 us
	load_property (TX_PREEMPHASIS);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_PILOT_FREQUENCY Prop...\r\n");
        #endif
	PILOT_FREQ = 19000;	//Hz
	load_property (TX_PILOT_FREQUENCY);
	waiting ();
	
	//  ,    77,    ,    ,   
	#ifdef DEBUG
        printf ("Loading TX_AUDIO_DEVIATION Prop...\r\n");
        #endif
	TXADEV = 6825;	//68.25*100 kHz
	load_property (TX_AUDIO_DEVIATION);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_PILOT_DEVIATION Prop...\r\n");
        #endif
	TXPDEV = 675;	//6.75*100 kHz
	load_property (TX_PILOT_DEVIATION);
	waiting ();
        
        #ifdef RDS_ENABLE 
        #ifdef DEBUG
        printf ("Loading TX_RDS_DEVIATION Prop...\r\n");
        #endif
	TXRDEV = 200;	//2*100 kHz
	load_property (TX_RDS_DEVIATION);
	waiting ();
	#endif
	
	#ifdef DEBUG
        printf ("****Tuning****\r\n");
        #endif
	
	#ifdef DEBUG
        printf ("Launching TX_TUNE_POWER CMD...\r\n");
        #endif
        RFdBu = 115;	//115dBuV
        ANTCAP = 0;	//auto
	launch_TX_TUNE_POWER (RFdBu, ANTCAP);
        waiting ();
        
//         #ifdef DEBUG
//         printf ("Launching TX_TUNE_FREQ CMD...\r\n");
//         #endif
//         FREQ = 10000;	//100.00 * 100 MHz
// 	launch_TX_TUNE_FREQ (FREQ);
//         waiting ();
//         #ifdef DEBUG
//         printf ("OK\r\n");
//         #endif
        
        #ifdef DEBUG
        printf ("Launching TX_TUNE_STATUS CMD...\r\n");
        #endif
        INTACK = 1;
	launch_TX_TUNE_STATUS (INTACK);
        waiting ();
        #ifdef DEBUG
        printf ("FREQ=%d, POWER=%d, CAP=%d\r\n", read_FREQ, read_RFdBu, read_ANTCAP);
        #endif
        
        #ifdef DEBUG
        printf ("Loading TX_COMPONENT_ENABLE Prop...\r\n");
        #endif
	RDS = 1;
	LMR = 1;
	PILOT = 1;
	load_property (TX_COMPONENT_ENABLE);
	waiting ();
	
	#ifdef DEBUG
        printf ("****Audio Compressor & Limiter****\r\n");
        #endif
	
	#ifdef DEBUG
        printf ("Loading TX_ACOMP_THRESHOLD Prop...\r\n");
        #endif
	THRESHOLD = 0xFFD8;	//-40dB
	load_property (TX_ACOMP_THRESHOLD);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ACOMP_GAIN Prop...\r\n");
        #endif
	GAIN = 15;	//15dB
	load_property (TX_ACOMP_GAIN);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ACOMP_RELEASE_TIME Prop...\r\n");
        #endif
	RELEASE = 4;	//1000ms
	load_property (TX_ACOMP_RELEASE_TIME);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ACOMP_ATTACK_TIME Prop...\r\n");
        #endif
	ATTACK = 2;	//1.5ms
	load_property (TX_ACOMP_ATTACK_TIME);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ACOMP_ENABLE Prop...\r\n");
        #endif
	LIMITEN = 1;	//. 
	ACEN = 1;       //. 
	load_property (TX_ACOMP_ENABLE);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_LIMITER_RELEASE_TIME Prop...\r\n");
        #endif
	LIMITERTC = 13; //39.38ms
	load_property (TX_LIMITER_RELEASE_TIME);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ASQ_LEVEL_LOW Prop...\r\n");
        #endif
	IALLTH = 0x00CE;	//-50dB
	load_property (TX_ASQ_LEVEL_LOW);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ASQ_DURATION_LOW Prop...\r\n");
        #endif
	IALLDUR = 10000;	//10000ms
	load_property (TX_ASQ_DURATION_LOW);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ASQ_LEVEL_HIGH Prop...\r\n");
        #endif
	IALHTH = 0x00EC;	//-20dB
	load_property (TX_ASQ_LEVEL_HIGH);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ASQ_DURATION_HIGH Prop...\r\n");
        #endif
	IALHDUR = 5000;		//5000ms
	load_property (TX_ASQ_DURATION_HIGH);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_ASQ_INTERRUPT_SOURCE Prop...\r\n");
        #endif
	OVERMODIEN = 1;
	IALHIEN = 1;
	IALLIEN = 1;
	load_property (TX_ASQ_INTERRUPT_SOURCE);
	waiting ();
	
	#ifdef DEBUG
        printf ("Launching TX_TUNE_STATUS CMD...\r\n");
        #endif
	INTACK = 0;
	launch_TX_ASQ_STATUS (INTACK);
        waiting ();
	#ifdef DEBUG
	printf ("FREQ=%d, OVERMOD=%d, INLEVEL=%d\r\n", read_FREQ, OVERMOD, INLEVEL);
	#endif
        
	#ifdef DEBUG
        printf ("Loading TX_LINE_INPUT_MUTE Prop...\r\n");
        #endif
	LIMUTE = RIMUTE = 0;	//mute
	load_property (TX_LINE_INPUT_MUTE);
	waiting ();

#ifdef RDS_ENABLE
	//******For RDS
        #ifdef DEBUG
        printf ("******RDS******\r\n");
        #endif
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_INTERRUPT_SOURCE Prop...\r\n");
        #endif
	RDSPSXMIT = 0;
	RDSCBUFXMIT = 0;
	RDSFIFOXMIT = 0;
	RDSCBUFWRAP = 0;
	RDSFIFOMT = 1;
	load_property (TX_RDS_INTERRUPT_SOURCE);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_PI Prop...\r\n");
        #endif
	RDSPI = 0x40A7;
	load_property (TX_RDS_PI);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_PS_MIX Prop...\r\n");
        #endif
	RDSPSMIX = 0x0003;
	load_property (TX_RDS_PS_MIX);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_PS_MISC Prop...\r\n");
        #endif
	RDSD3 = 0;
	RDSD2 = 0;
	RDSD1 = 0;
	RDSD0 = 1;
	FORCEB = 0;
	RDSTP = 0;
	RDSPTY = 0;
	RDSTA = 0;
	RDSMS = 1;
	load_property (TX_RDS_PS_MISC);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_PS_REPEAT_COUNT Prop...\r\n");
        #endif
	RDSPSRC = 1;
	load_property (TX_RDS_PS_REPEAT_COUNT);
	waiting ();
	
	#ifdef DEBUG
        printf ("Loading TX_RDS_PS_AF Prop...\r\n");
        #endif
	RDSAF = 0xE0E0;	//no exist
	load_property (TX_RDS_PS_AF);
	waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_RDS_PS_MESSAGE_COUNT Prop...\r\n");
        #endif
	RDSPSMC = 12;	// PS-, 12 	
	load_property (TX_RDS_PS_MESSAGE_COUNT);
	waiting ();

	#ifdef DEBUG
        printf ("Loading TX_RDS_FIFO_SIZE Prop...\r\n");
        #endif
	RDSFIFOSZ = 13;	//12  FIFO-,  .  1 
	load_property (TX_RDS_FIFO_SIZE);
	waiting ();
	
	#ifdef DEBUG
        printf ("Launching TX_RDS_PS CMD...\r\n");
        #endif
        launch_TX_RDS_PS (0, 'U', 'S', 'B', '-');	//   
        waiting ();
        launch_TX_RDS_PS (1, 'r', 'a', 'd', 'i');
        waiting ();
        launch_TX_RDS_PS (2, 'S', 'B', '-', 'r');
        waiting ();
        launch_TX_RDS_PS (3, 'a', 'd', 'i', 'o');
        waiting ();
        launch_TX_RDS_PS (4, 'B', '-', 'r', 'a');
        waiting ();
        launch_TX_RDS_PS (5, 'd', 'i', 'o', ' ');
        waiting ();
        launch_TX_RDS_PS (6, '-', 'r', 'a', 'd');
        waiting ();
        launch_TX_RDS_PS (7, 'i', 'o', ' ', 'b');
        waiting ();
        launch_TX_RDS_PS (8, 'r', 'a', 'd', 'i');
        waiting ();
        launch_TX_RDS_PS (9, 'o', ' ', 'b', 'y');
        waiting ();
        launch_TX_RDS_PS (10, 'a', 'd', 'i', 'o');
        waiting ();
        launch_TX_RDS_PS (11, ' ', 'b', 'y', ' ');
        waiting ();
        launch_TX_RDS_PS (12, 'd', 'i', 'o', ' ');
        waiting ();
        launch_TX_RDS_PS (13, 'b', 'y', ' ', 'A');
        waiting ();
        launch_TX_RDS_PS (14, 'i', 'o', ' ', 'b');
        waiting ();
        launch_TX_RDS_PS (15, 'y', ' ', 'A', 'h');
        waiting ();
        launch_TX_RDS_PS (16, 'o', ' ', 'b', 'y');
        waiting ();
        launch_TX_RDS_PS (17, ' ', 'A', 'h', 'e');
        waiting ();
        launch_TX_RDS_PS (18, ' ', 'b', 'y', ' ');
        waiting ();
        launch_TX_RDS_PS (19, 'A', 'h', 'e', 'i');
        waiting ();
        launch_TX_RDS_PS (20, 'b', 'y', ' ', 'A');
        waiting ();
        launch_TX_RDS_PS (21, 'h', 'e', 'i', 'r');
        waiting ();
        launch_TX_RDS_PS (22, 'y', ' ', 'A', 'h');
        waiting ();
        launch_TX_RDS_PS (23, 'e', 'i', 'r', '!');
        waiting ();
        
        #ifdef DEBUG
        printf ("Loading TX_COMPONENT_ENABLE Prop...\r\n");
        #endif
	RDS = 1;
	LMR = 1;
	PILOT = 1;
	load_property (TX_COMPONENT_ENABLE);
	waiting ();
#endif       
        
        
                                                                                 
	}